; timer2_bitflip.a51	use Timer2 to toggle LED, on interrupt by timer overflow

; rev path 3/16
	$NOSYMBOLS		; keeps listing short
	$INCLUDE (C:\SiLabs\MCU\INC\c8051f410.inc) 
	$INCLUDE (C:\SiLabs\MCU\INC\VECTORS320.INC)	; Tom's vectors definition file

	STACKBOT EQU 80h					; put stack at start of scratch
	DIV12 EQU 0DFh						; timer clock mask to div by 12, in CKCON
	TIM2INTEN EQU IE.5
	TIM2_ENABLE EQU TMR2CN.2
	SOFTFLAG EQU 0						; software flag that ISR uses to talk to Main
	BLUE_LED EQU P0.0					; LED to toggle
	
	 HITIME SET 0FFh	; set start count close to the overflow val
	 LOTIME SET 0F0H	;  ...and this is the low byte

; port use:
; 	LED at P0.0
	
	ORG 0
	SJMP STARTUP
	
	ORG 80h
STARTUP: acall USUAL_SETUP
	ACALL IO_SETUP
	ACALL TIMER_INITS
 
	SETB TIM2_ENABLE
	

STUCK:	SJMP STUCK	; await interrupts.  All the action is there
	
		
;------------------------------
; ISR: JUST TOGGLE LED
	ORG TIMER2VECTOR
ISR:	CPL BLUE_LED
	CLR TF2H		; Clear timer-2 overflow flag (does this clear interrupt flag?)
	RETI	 

  
 ;------- INITIALIZATIONS
;--- SUBROUTINES ----
USUAL_SETUP: ANL   PCA0MD, #NOT(040h)        ; Disable the WDT.
                                             ; Clear Watchdog Enable bit

				; Configure the Oscillator
             ORL   OSCICN, #04h         ; sysclk = 24.5 Mhz / 8

         ; Enable the Port I/O Crossbar

            MOV   XBR1, #40h           ; Enable Crossbar
						RET
						
TIMER_INITS:
	anl CKCON, #DIV12		; set timer clock to system/12	

	MOV TMR2CN, #04h		; enable timer 2, and 16-bit auto-reload
	
	MOV TMR2H, #HITIME  ; these are the initial values (for short first pass,
	MOV TMR2L, #LOTIME  ;  when we may be watching in single-step)
	
	MOV TMR2RLH, #00h		; reload values (chosen for maximum delay, after quick first pass)
	MOV TMR2RLL, #00h
	
; ----NOW ENABLE INTERRUPTS----
	SETB TIM2INTEN		; timer-2 interrupt enable
;	SETB GLOBALINTEN	; Global int enable
	setb EA				; ditto

	RET

IO_SETUP: orl P0MDOUT, #01h								; enable P0.0 as push-pull output
			RET

		  END						
						
